﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace CVP_ToolTip_MVVM
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class DataGridViewModel : PropertyChangedNotifier
    {
        private ObservableCollection<DataVM> data;

        public DataGridViewModel()
        {
            Data = new ObservableCollection<DataVM>();

            for (int i = 0; i < 10; i++)
            {
                Data.Add(new DataVM
                {
                    ID = i,
                    Name = "Name " + i,
                    Age = 15 + i,
                });
            }
        }

        public ObservableCollection<DataVM> Data
        {
            get { return data; }
            set { data = value; }
        }

    }

    public class DataVM : PropertyChangedNotifier
    {
        private int id;

        public int ID
        {
            get { return id; }
            set { id = value; OnPropertyChagned("ID"); }
        }


        private string name;

        public string Name
        {
            get { return name; }
            set { name = value; OnPropertyChagned("Name"); }
        }

        private int age;

        public int Age
        {
            get { return age; }
            set { age = value; OnPropertyChagned("Age"); }
        }


    }

    public class PropertyChangedNotifier :  INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
